
// Method to convert the IMAGE construct into a BOX && MASK
// Needed because MASK is an exclusive construct
String & convImageExpression(string &e, *table);
{

  // Extract the IMAGE construction
    unsigned i0 = 0;
    AttString a = findNextAttribute(e, i0);
    while(a.len) {

        // Check if the attribute is IMAGE
        std::string att(e.substr(a.pos+1, a.len-1));
        if (upcase(att) == "IMAGE") // or something
         {
           string newbit = interpretImageExpr(att, *table);
           e.replace(a.pos, a.len, newbit);
         }

        i0 = a.pos+1;
        a = findNextAttribute(e, i0);
    }

}
// Method to interpret IMAGE as BOX
String & interpretImageExpr(string att, *table);
{
  // Find the extent of the image
      /* Set a DSS object */
    DataSubspace dss = dssBuilder.getDss(att);

    string Xaxis, Yaxis;

    if (srcexp.find("DET") != string::npos) {
       Xaxis="DETX", Yaxis="DETY";
    } else if (srcexp.find("RAW") != string::npos){
       Xaxis="RAWX", Yaxis="RAWY";
    } else if (srcexp.find("DEC") != string::npos) {
       Xaxis="RA", Yaxis="DEC";
    } else {
       Xaxis="X", Yaxis="Y";
    }

    Range<double> extentX = dss.realextent(Xaxis);
    Range<double> extentY = dss.realextent(Yaxis);

    extentX.values(xmin, xmax, lxb,uxb);
    extentY.values(ymin, ymax, lyb,uyb);

    double xcen = (xmax+xmin) / 2.0;
    double ycen = (ymax+ymin) / 2.0;
    double xhwid = abs(xcen - xmin);
    double yhwid = abs(ycen - ymin);
    //s = SImage(att.image());
    //extents = s.extents();

    // Define a BOX expression encompassing the Image
    string b = "("+Xaxis+","+Yaxis+") in BOX("+xcen+","+ycen+","+xhwid
                  +","+yhwid+",0)";

    // Add the original IMAGE expression as a MASK
    string c = upcase(att);
    c.replace(c.find("IMAGE"),5,"MASK");
    b = b + "&&" + c;

    return b;
} 
